<script>
import Vue from 'vue';
import SlpCloseModal from '~/static/nuxt-images/video-carousels/close-modal-icon.vue';

export default Vue.extend({
  name: 'SolutionsVideoModal',
  // v-if used in this component will break GTM tracking. Use v-show instead
  components: {
    SlpCloseModal,
  },
  props: {
    lightBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
  },
  watch: {
    visible(newValue) {
      if (newValue) {
        document.querySelector('body').classList.add('noScroll');
        setTimeout(() => {
          window.__vimeoRefresh();
        }, 3000);
      } else {
        document.querySelector('body').classList.remove('noScroll');
        const videoSection = this.$refs.videoSection;

        // Pause Vimeo video
        const liteVimeo = videoSection.querySelector('lite-vimeo');
        if (liteVimeo) {
          const iframe = liteVimeo.shadowRoot.querySelector('iframe');
          if (iframe) {
            iframe.contentWindow.postMessage(
              JSON.stringify({
                method: 'pause',
              }),
              '*',
            );
          }
        }

        // Pause lite YouTube video
        const liteYouTube = document.querySelector('lite-youtube');
        if (liteYouTube) {
          const iframe = liteYouTube.querySelector('iframe');

          if (iframe) {
            if (!iframe.src.includes('enablejsapi=1')) {
              iframe.src +=
                (iframe.src.includes('?') ? '&' : '?') + 'enablejsapi=1';

              iframe.onload = () => {
                iframe.contentWindow.postMessage(
                  JSON.stringify({
                    event: 'command',
                    func: 'pauseVideo',
                    args: [],
                  }),
                  '*',
                );
              };
            } else {
              iframe.contentWindow.postMessage(
                JSON.stringify({
                  event: 'command',
                  func: 'pauseVideo',
                  args: [],
                }),
                '*',
              );
            }
          }
        }
      }
    },
  },

  methods: {
    close() {
      this.$emit('close');
    },
  },
});
</script>
<template>
  <div
    :class="[
      lightBackground
        ? 'modal__backdrop modal__backdrop--light'
        : 'modal__backdrop',
    ]"
    @click.self="close"
  >
    <div class="modal">
      <header class="modal__header">
        <slot name="header"></slot>
        <button type="button" class="btn btn__close" @click="close">
          <SlpCloseModal />
        </button>
      </header>
      <section ref="videoSection" class="modal__body">
        <slot name="body"></slot>
      </section>
      <footer class="modal__footer">
        <slot name="footer"></slot>
      </footer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;
  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
    &--light {
      background-color: #d1d0d3c4;
    }
  }

  &__header {
    position: relative;
    justify-content: space-between;
    background-color: transparent;
  }
  &__header,
  &__footer {
    padding: $spacing-16;
    display: flex;
  }
  &__body {
    position: relative;
    padding: $spacing-8;
    lite-vimeo {
      border-radius: $border-radius-4;
      border: none;
      width: 330px;
      height: 200px;
      @media (min-width: $breakpoint-md) {
        width: 700px;
        height: 390px;
      }
      @media (min-width: $breakpoint-lg) {
        width: 920px;
        height: 516px;
      }
    }
  }
}
.btn {
  &__close {
    position: absolute;
    right: -$spacing-8;
    width: 45px;
    height: 45px;
    top: 0;
    border: none;
    border-radius: 50%;
    cursor: pointer;
    @media (min-width: $breakpoint-lg) {
      right: -$spacing-24;
    }

    svg {
      width: 100%;
      height: 100%;
    }
  }
}
</style>
